/******************************************************************************
** Copyright (C) 2007  Pablo Garcia
** 
** This library is free software; you can redistribute it and/or
** modify it under the terms of the GNU Lesser General Public
** License as published by the Free Software Foundation; either
** version 2.1 of the License, or (at your option) any later version.

** This library is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
** Lesser General Public License for more details.

** You should have received a copy of the GNU Lesser General Public
** License along with this library; if not, write to the Free Software
** Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
******************************************************************************/

/**\file**********************************************************************
 File Name	:	Constants.h
 Project	:  	TIMotorLIB
 TI Doc:		na 
 \author	  	Pablo Garcia (pgarcia@isa.uniovi.es)
 \brief 		Define PI and derivated values
 \details		Trigonometric constants and macros for conversions from radians
 to degrees and degrees to radians.
 \date 			2007 
******************************************************************************/

#ifndef CONSTANTS_H
#define CONSTANTS_H

#include "IQConstants.h"

#ifdef PI
#undef PI
#endif


#define PI             	(_IQ(3.1415926535897932384626433832795))
#define PIDIV2         	(_IQ(1.5707963267948))
#define PIDIV3         	(_IQ(1.047197551196598))
#define TWOPI          	(_IQ(6.28318530717959))
#define THREEPI         (_IQ(9.42477796076937))
#define FOURPI         	(_IQ(12.56637061435917))
#define TWOPIDIV3      	(_IQ(2.09439510239320))
#define PIDIV4		(_IQ(0.785398163397))
#define THREEPIDIV4	(_IQ(2.35619449019234))
#define FIVEPIDIV4      (_IQ(3.92699081698724))
#define SEVENPIDIV4     (_IQ(5.49778714378214))
#define THREEPIDIV2    	(_IQ(4.7123889803846))
#define SQRT2          	(_IQ(1.41421356237310))
#define SQRT2DIV2      	(_IQ(0.70710678118655))
#define SQRT3          	(_IQ(1.73205080756888))
#define SQRT3DIV2      	(_IQ(0.86602540378444))
#define SQRT3DIV3      	(_IQ(0.57735026918963))
#define TWOSQRT3DIV3   	(_IQ(1.15470053837925))
#define ONESIXTH       	(_IQ(0.166666666666667))
#define ONETHIRD       	(_IQ(0.33333333333333))
#define THIRTYOVERPI	(_IQ(30.0/PI))	// better defined as exact values
#define PIOVERTHIRTY	(_IQ(PI/30))
#define PIOVER5		(_IQ(PI/5))
#define PIOVER6		(_IQ(0.523598775598299))
#define DEG2RAD(deg)	(_IQmpy(_IQ(0.0174532925199),deg)) ///< convert degrees to radians
#define RAD2DEG(rad)	(_IQmpy(_IQ(57.295779513082),rad)) ///< convert radians to degrees

#endif

//-----------------------------------------------------------------------------
// End Of File
//-----------------------------------------------------------------------------

