/******************************************************************************
** Copyright (C) 2007  Pablo Garcia
** 
** This library is free software; you can redistribute it and/or
** modify it under the terms of the GNU Lesser General Public
** License as published by the Free Software Foundation; either
** version 2.1 of the License, or (at your option) any later version.

** This library is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
** Lesser General Public License for more details.

** You should have received a copy of the GNU Lesser General Public
** License along with this library; if not, write to the Free Software
** Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
******************************************************************************/

/**\file *********************************************************************
 File Name	:	Filters10kHz.h
 Project	:  	TIMotorLIB
 
 TI Doc:		na
 \author  		Pablo Garcia (pgarcia@isa.uniovi.es)
 \date 			2007
 \brief 		Fixed point filter specifications for 100us sample time
******************************************************************************/

#define B0_HPF5	523466
#define A1_HPF5	522643
#define FILTER_D_HPF5(in,out)	out.d[N]=_IQmpy(B0_HPF5,(in.d[N]-in.d[N1]))+_IQmpy(A1_HPF5,out.d[N1])
#define FILTER_Q_HPF5(in,out)	out.q[N]=_IQmpy(B0_HPF5,(in.q[N]-in.q[N1]))+_IQmpy(A1_HPF5,out.q[N1])
#define FILTER_QD_HPF5(in,out)	FILTER_Q_HPF5(in,out); FILTER_D_HPF5(in,out)

#define B0_LPF5	822
#define A1_LPF5	522643
#define FILTER_D_LPF5(in,out)	out.d[N]=_IQmpy(B0_LPF5,(in.d[N]+in.d[N1]))+_IQmpy(A1_LPF5,out.d[N1])
#define FILTER_Q_LPF5(in,out)	out.q[N]=_IQmpy(B0_LPF5,(in.q[N]+in.q[N1]))+_IQmpy(A1_LPF5,out.q[N1])
#define FILTER_QD_LPF5(in,out)	FILTER_Q_LPF5(in,out); FILTER_D_LPF5(in,out)

#define B0_HPF10	522646
#define A1_HPF10	521004
#define FILTER_D_HPF10(in,out)	out.d[N]=_IQmpy(B0_HPF10,(in.d[N]-in.d[N1]))+_IQmpy(A1_HPF10,out.d[N1])
#define FILTER_Q_HPF10(in,out)	out.q[N]=_IQmpy(B0_HPF10,(in.q[N]-in.q[N1]))+_IQmpy(A1_HPF10,out.q[N1])
#define FILTER_QD_HPF10(in,out)	FILTER_Q_HPF10(in,out); FILTER_D_HPF10(in,out)

#define B0_LPF10	1642
#define A1_LPF10	521004
#define FILTER_D_LPF10(in,out)	out.d[N]=_IQmpy(B0_LPF10,(in.d[N]+in.d[N1]))+_IQmpy(A1_LPF10,out.d[N1])
#define FILTER_Q_LPF10(in,out)	out.q[N]=_IQmpy(B0_LPF10,(in.q[N]+in.q[N1]))+_IQmpy(A1_LPF10,out.q[N1])
#define FILTER_QD_LPF10(in,out)	FILTER_Q_LPF10(in,out); FILTER_D_LPF10(in,out)

#define B0_HPF100	508319
#define A1_HPF100	492349
#define FILTER_D_HPF100(in,out)	out.d[N]=_IQmpy(B0_HPF100,(in.d[N]-in.d[N1]))+_IQmpy(A1_HPF100,out.d[N1])
#define FILTER_Q_HPF100(in,out)	out.q[N]=_IQmpy(B0_HPF100,(in.q[N]-in.q[N1]))+_IQmpy(A1_HPF100,out.q[N1])
#define FILTER_QD_HPF100(in,out)	FILTER_Q_HPF100(in,out); FILTER_D_HPF100(in,out)

#define B0_LPF100	15969
#define A1_LPF100	492349
#define FILTER_LPF100(in,out)		out[N]=_IQmpy(B0_LPF100,(in[N]+in[N1]))+_IQmpy(A1_LPF100,out[N1])
#define FILTER_D_LPF100(in,out)	out.d[N]=_IQmpy(B0_LPF100,(in.d[N]+in.d[N1]))+_IQmpy(A1_LPF100,out.d[N1])
#define FILTER_Q_LPF100(in,out)	out.q[N]=_IQmpy(B0_LPF100,(in.q[N]+in.q[N1]))+_IQmpy(A1_LPF100,out.q[N1])
#define FILTER_QD_LPF100(in,out)	FILTER_Q_LPF100(in,out); FILTER_D_LPF100(in,out)

#define B0_HPF200	493293
#define A1_HPF200	462299
#define FILTER_D_HPF200(in,out)	out.d[N]=_IQmpy(B0_HPF200,(in.d[N]-in.d[N1]))+_IQmpy(A1_HPF200,out.d[N1])
#define FILTER_Q_HPF200(in,out)	out.q[N]=_IQmpy(B0_HPF200,(in.q[N]-in.q[N1]))+_IQmpy(A1_HPF200,out.q[N1])
#define FILTER_QD_HPF200(in,out)	FILTER_Q_HPF200(in,out); FILTER_D_HPF200(in,out)

#define B0_LPF200	30995
#define A1_LPF200	462299
#define FILTER_LPF200(in,out)	out[N]=_IQmpy(B0_LPF200,(in[N]+in[N1]))+_IQmpy(A1_LPF200,out[N1])
#define FILTER_D_LPF200(in,out)	out.d[N]=_IQmpy(B0_LPF200,(in.d[N]+in.d[N1]))+_IQmpy(A1_LPF200,out.d[N1])
#define FILTER_Q_LPF200(in,out)	out.q[N]=_IQmpy(B0_LPF200,(in.q[N]+in.q[N1]))+_IQmpy(A1_LPF200,out.q[N1])
#define FILTER_QD_LPF200(in,out)	FILTER_Q_LPF200(in,out); FILTER_D_LPF200(in,out)

#define B0_HPF300	479131
#define A1_HPF300	433974
#define FILTER_D_HPF300(in,out)	out.d[N]=_IQmpy(B0_HPF300,(in.d[N]-in.d[N1]))+_IQmpy(A1_HPF300,out.d[N1])
#define FILTER_Q_HPF300(in,out)	out.q[N]=_IQmpy(B0_HPF300,(in.q[N]-in.q[N1]))+_IQmpy(A1_HPF300,out.q[N1])
#define FILTER_QD_HPF300(in,out)	FILTER_Q_HPF300(in,out); FILTER_D_HPF300(in,out)

#define B0_LPF300	45157
#define A1_LPF300	433974
#define FILTER_LPF300(in,out)	out[N]=_IQmpy(B0_LPF300,(in[N]+in[N1]))+_IQmpy(A1_LPF300,out[N1])
#define FILTER_D_LPF300(in,out)	out.d[N]=_IQmpy(B0_LPF300,(in.d[N]+in.d[N1]))+_IQmpy(A1_LPF300,out.d[N1])
#define FILTER_Q_LPF300(in,out)	out.q[N]=_IQmpy(B0_LPF300,(in.q[N]+in.q[N1]))+_IQmpy(A1_LPF300,out.q[N1])
#define FILTER_QD_LPF300(in,out)	FILTER_Q_LPF300(in,out); FILTER_D_LPF300(in,out)

#define B0_LPF500	71175
#define A1_LPF500	381938
#define FILTER_D_LPF500(in,out)	out.d[N]=_IQmpy(B0_LPF500,(in.d[N]+in.d[N1]))+_IQmpy(A1_LPF500,out.d[N1])
#define FILTER_Q_LPF500(in,out)	out.q[N]=_IQmpy(B0_LPF500,(in.q[N]+in.q[N1]))+_IQmpy(A1_LPF500,out.q[N1])
#define FILTER_QD_LPF500(in,out)	FILTER_Q_LPF500(in,out); FILTER_D_LPF500(in,out)

#define B0_HPF500	453113
#define A1_HPF500	381938
#define FILTER_D_HPF500(in,out)	out.d[N]=_IQmpy(B0_HPF500,(in.d[N]-in.d[N1]))+_IQmpy(A1_HPF500,out.d[N1])
#define FILTER_Q_HPF500(in,out)	out.q[N]=_IQmpy(B0_HPF500,(in.q[N]-in.q[N1]))+_IQmpy(A1_HPF500,out.q[N1])
#define FILTER_QD_HPF500(in,out)	FILTER_Q_HPF500(in,out); FILTER_D_HPF500(in,out)

#define B0_LPF700	94513
#define A1_LPF700	335263
#define FILTER_D_LPF700(in,out)	out.d[N]=_IQmpy(B0_LPF700,(in.d[N]+in.d[N1]))+_IQmpy(A1_LPF700,out.d[N1])
#define FILTER_Q_LPF700(in,out)	out.q[N]=_IQmpy(B0_LPF700,(in.q[N]+in.q[N1]))+_IQmpy(A1_LPF700,out.q[N1])
#define FILTER_QD_LPF700(in,out)	FILTER_Q_LPF700(in,out); FILTER_D_LPF700(in,out)

#define B0_HPF700	429775
#define A1_HPF700	335263
#define FILTER_D_HPF700(in,out)	out.d[N]=_IQmpy(B0_HPF700,(in.d[N]-in.d[N1]))+_IQmpy(A1_HPF700,out.d[N1])
#define FILTER_Q_HPF700(in,out)	out.q[N]=_IQmpy(B0_HPF700,(in.q[N]-in.q[N1]))+_IQmpy(A1_HPF700,out.q[N1])
#define FILTER_QD_HPF700(in,out)	FILTER_Q_HPF700(in,out); FILTER_D_HPF700(in,out)

#define B0_BUTTER_LPF10	50
#define B1_BUTTER_LPF10	101
#define B2_BUTTER_LPF10	50
#define A1_BUTTER_LPF10	1033941
#define A2_BUTTER_LPF10	-509855
#define FILTER_D_BUTTER_LPF10(in,out)	out.d[N]=_IQmpy(B0_BUTTER_LPF10,(in.d[N]+in.d[N2]))+_IQmpy(B1_BUTTER_LPF10,in.d[N1])+_IQmpy(A1_BUTTER_LPF10,out.d[N1])+_IQmpy(A2_BUTTER_LPF10,out.d[N2])
#define FILTER_Q_BUTTER_LPF10(in,out)	out.q[N]=_IQmpy(B0_BUTTER_LPF10,(in.q[N]+in.q[N2]))+_IQmpy(B1_BUTTER_LPF10,in.q[N1])+_IQmpy(A1_BUTTER_LPF10,out.q[N1])+_IQmpy(A2_BUTTER_LPF10,out.q[N2])
#define FILTER_QD_BUTTER_LPF10(in,out)	FILTER_Q_BUTTER_LPF10(in,out); FILTER_D_BUTTER_LPF10(in,out)

#define B0_BUTTER_HPF10	517021
#define B1_BUTTER_HPF10	1034042
#define B2_BUTTER_HPF10	517021
#define A1_BUTTER_HPF10	1033941
#define A2_BUTTER_HPF10	509855
#define FILTER_D_BUTTER_HPF10(in,out)	out.d[N]=_IQmpy(B0_BUTTER_HPF10,(in.d[N]+in.d[N2]))-_IQmpy(B1_BUTTER_HPF10,in.d[N1])+_IQmpy(A1_BUTTER_HPF10,out.d[N1])-_IQmpy(A2_BUTTER_HPF10,out.d[N2])
#define FILTER_Q_BUTTER_HPF10(in,out)	out.q[N]=_IQmpy(B0_BUTTER_HPF10,(in.q[N]+in.q[N2]))-_IQmpy(B1_BUTTER_HPF10,in.q[N1])+_IQmpy(A1_BUTTER_HPF10,out.q[N1])-_IQmpy(A2_BUTTER_HPF10,out.q[N2])
#define FILTER_QD_BUTTER_HPF10(in,out)	FILTER_Q_BUTTER_HPF10(in,out); FILTER_D_BUTTER_HPF10(in,out)

//-----------------------------------------------------------------------------
// End Of File
//-----------------------------------------------------------------------------


