/******************************************************************************
** Copyright (C) 2007  Pablo Garcia
** 
** This library is free software; you can redistribute it and/or
** modify it under the terms of the GNU Lesser General Public
** License as published by the Free Software Foundation; either
** version 2.1 of the License, or (at your option) any later version.

** This library is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
** Lesser General Public License for more details.

** You should have received a copy of the GNU Lesser General Public
** License along with this library; if not, write to the Free Software
** Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
******************************************************************************/

/**\file**********************************************************************
 File Name	:	IQConstants.h
 Project	:  	TIMotorLIB
 
 TI Doc:		<a href="http://focus.ti.com/lit/sw/sprc990/sprc990.pdf"> SPRC990</a>
 \author  		Pablo Garcia (pgarcia@isa.uniovi.es)
 \date 			2007
 \brief 		Fixed point/Floating point selection and GLOBAL_Q value
******************************************************************************/

//-----------------------------------------------------------------------------
//	Define
//-----------------------------------------------------------------------------
#ifndef IQCONSTANTS_H
#define IQCONSTANTS_H

// Select the global Q value to use:

/// FIXED/FLOAT POINT ARITHMETIC. Change in Preprocessor symbols under project compiling options (-d)
#ifdef  FIXED_POINT_LIB
	#ifndef GLOBAL_Q
		#define	GLOBAL_Q	19
	#endif
	#define MATH_TYPE IQ_MATH
	#include "IQmathLib.h"
#else
	#ifndef GLOBAL_Q
		#define	GLOBAL_Q	19
	#endif
	#define MATH_TYPE FLOAT_MATH
    #include <math.h>
	#include "IQmathLib.h"
	/*	PABLO: 	These operation are now included in IQmathLib.h when FLOAT_MATH flag is set
				(the same approach I used but for every operation in the library :-) )
	// define here all needed operations and variables for float point operation
	typedef float _iq;
	#define _IQ(a) 			(a)
	#define _IQtoF(a) 		(a)
	#define _IQmpy(a,b)		(a*b)
	#define _IQdiv(a,b)		(a/b)
	#define _IQcos(a) 		(cos(a))
	#define _IQsin(a) 		(sin(a))
	*/
#endif

#endif

//-----------------------------------------------------------------------------
// End Of File
//-----------------------------------------------------------------------------
